#!/bin/bash
set -e
make

USE_DEF_LOSS=$1
LAMBDA=$2
USE_ORTHO_LOSS=$3
BETA=$4
USE_PROJ_LOSS=$5
GAMMA=$6
MAX_ITER=$7

VERBOSE=2
MEMORY=250.0
VOCAB_MIN_COUNT=5
MAX_VOCAB=400000
VECTOR_SIZE=300
WINDOW_SIZE=10
BINARY=2
NUM_THREADS=32
X_MAX=100

CORPUS=/home/students/reichelt/ba/bias-mitigation-ba/data/wikipedia/wikipedia_preprocessed.txt
VOCAB_FILE=/home/students/reichelt/ba/bias-mitigation-ba/data/embeddings/glove/dd-glove/vocab.txt
COOCCURRENCE_FILE=/home/students/reichelt/ba/bias-mitigation-ba/data/embeddings/glove/dd-glove/cooccurrence.bin
COOCCURRENCE_SHUF_FILE=/home/students/reichelt/ba/bias-mitigation-ba/data/embeddings/glove/dd-glove/cooccurrence.shuf.bin
BUILDDIR=/home/students/reichelt/ba/bias-mitigation-ba/DD-GloVe/build_turkish
SAVE_FILE=/home/students/reichelt/ba/bias-mitigation-ba/data/embeddings/glove/dd-glove/glove_dd_turkish
VECTOR_TEXT_FILE=$SAVE_FILE.txt

if hash python 2>/dev/null; then
    PYTHON=python
else
    PYTHON=python3
fi

echo
# echo "$ $BUILDDIR/vocab_count -min-count $VOCAB_MIN_COUNT -max-vocab $MAX_VOCAB -verbose $VERBOSE < $CORPUS > $VOCAB_FILE"
# $BUILDDIR/vocab_count -min-count $VOCAB_MIN_COUNT -max-vocab $MAX_VOCAB -verbose $VERBOSE < $CORPUS > $VOCAB_FILE
# echo "$ $BUILDDIR/cooccur -memory $MEMORY -vocab-file $VOCAB_FILE -verbose $VERBOSE -window-size $WINDOW_SIZE < $CORPUS > $COOCCURRENCE_FILE"
# $BUILDDIR/cooccur -memory $MEMORY -vocab-file $VOCAB_FILE -verbose $VERBOSE -window-size $WINDOW_SIZE < $CORPUS > $COOCCURRENCE_FILE
# echo "$ $BUILDDIR/shuffle -memory $MEMORY -verbose $VERBOSE < $COOCCURRENCE_FILE > $COOCCURRENCE_SHUF_FILE"
# $BUILDDIR/shuffle -memory $MEMORY -verbose $VERBOSE < $COOCCURRENCE_FILE > $COOCCURRENCE_SHUF_FILE
#echo "$ $PYTHON get_definition.py --vocab_file $VOCAB_FILE --def_source dduw --max_vocab_size $MAX_VOCAB"
#$PYTHON get_definition.py --vocab_file $VOCAB_FILE --def_source dduw --max_vocab_size $MAX_VOCAB

echo "$ $BUILDDIR/glove -save-file $SAVE_FILE -threads $NUM_THREADS -input-file $COOCCURRENCE_SHUF_FILE -x-max $X_MAX \
-iter $MAX_ITER -vector-size $VECTOR_SIZE -binary $BINARY -vocab-file $VOCAB_FILE -verbose $VERBOSE \
-use-def-loss $USE_DEF_LOSS -lambda $LAMBDA -use-ortho-loss $USE_ORTHO_LOSS -beta $BETA -use-proj-loss $USE_PROJ_LOSS -gamma $GAMMA -seed 42"
$BUILDDIR/glove -save-file $SAVE_FILE -threads $NUM_THREADS -input-file $COOCCURRENCE_SHUF_FILE -x-max $X_MAX \
-iter $MAX_ITER -vector-size $VECTOR_SIZE -binary $BINARY -vocab-file $VOCAB_FILE -verbose $VERBOSE -write-header 1 \
-use-def-loss $USE_DEF_LOSS -lambda $LAMBDA -use-ortho-loss $USE_ORTHO_LOSS -beta $BETA -use-proj-loss $USE_PROJ_LOSS -gamma $GAMMA -seed 42
