"""Short helper script to look up vocab counts of ~400 names in GloVe vocabulary"""
from tqdm import tqdm

with open("names.txt", "r", encoding="utf-8") as names_file:
    names = names_file.readlines()

names = [name.strip().lower() for name in names]

counts = []

with open("data/embeddings/glove/dd-glove/vocab.txt", "r", encoding="utf-8") as vocab_file:
    vocab = vocab_file.readlines()
    for name in tqdm(names):  # this is inefficient but using dictionaries doesn't work
        for line in vocab:
            token, count = line.strip().split()
            if token == name:
                counts.append(count)
                found = True
                break
        if found == False:
            counts.append(0)
        found = False

print(len(names))
print(len(counts))

with open("name_counts.csv", "w+", encoding="utf-8") as output:
    for i, name in enumerate(names):
        output.write(f"{name},{counts[i]}\n")
