"""
Download Wikipedia dump using huggingface and preprocess it
using nltk tokenizer, lowercasing, punctuation removal
"""

from tqdm import tqdm
from nltk.tokenize import word_tokenize
from datasets import load_dataset

wikipedia = load_dataset("wikipedia", "20220301.en")
wikipedia = wikipedia["train"]

with open("/workspace/students/reichelt/BA/data/wikipedia/english_wikipedia_preprocessed.txt",
          "w+", encoding="utf-8") as f:
    for article in tqdm(wikipedia):
        tokenized = word_tokenize(article["text"], language='english')
        tokenized = [token.lower() for token in tokenized]
        JOINED = " ".join(tokenized)
        f.write(JOINED + "\n")
